## gnudatalanguage 1.0.1

=== CMakeLists.txt ===
#
# copyright : (c) 2010 Maxime Lenoir and Alain Coulais
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#

cmake_minimum_required(VERSION 3.2 FATAL_ERROR)

# Set some policies to fix warnings in newer versions of cmake
# Since VERSION_GREATER_EQUAL is available only since 3.7, we use 
# VERSION_GREATER combined with VERSION_EQUAL to achieve what we want

if (CMAKE_MINOR_VERSION GREATER 12)
  if (CMAKE_VERSION VERSION_GREATER "3.12.0" OR CMAKE_VERSION VERSION_EQUAL "3.12.0")
      cmake_policy(SET CMP0075 NEW)
  endif(CMAKE_VERSION VERSION_GREATER "3.12.0" OR CMAKE_VERSION VERSION_EQUAL "3.12.0")
  if (CMAKE_VERSION VERSION_GREATER "3.13.0" OR CMAKE_VERSION VERSION_EQUAL "3.13.0")
      cmake_policy(SET CMP0077 NEW)
  endif(CMAKE_VERSION VERSION_GREATER "3.13.0" OR CMAKE_VERSION VERSION_EQUAL "3.13.0")
endif (CMAKE_MINOR_VERSION GREATER 12)

project(GDL)
set(CMAKE_CXX_STANDARD 11)

# advice by Orion, mandatory for FC 28
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# X.X.X git becomes release X.X.X+1
set(VERSION "1.0.1")
enable_testing()

# cf issue 511, managing MultiArch on Debian ...
include(GNUInstallDirs)

include(CheckIncludeFile)
include(CheckIncludeFileCXX)
include(CheckLibraryExists)
include(CheckFunctionExists)
include(CheckSymbolExists)
include(CheckCSourceRuns)
include(CheckCXXSourceCompiles)
include(FindPkgConfig)
include(FindPackageHandleStandardArgs)
include(TestBigEndian)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/CMakeModules)
#### GDL is an interactive tool. Normally INTERACTIVE_GRAPHICS must be set
set(INTERACTIVE_GRAPHICS ON CACHE BOOL "GDL: Disable check of existence of a suited graphics driver in plplot.)")

#### Default cached values
set(GDLDEV OFF CACHE BOOL "GDL: Enable GDL developer mode (includes work-in-progress tests)")

set(PYTHON_MODULE OFF CACHE BOOL "GDL: Build GDL as a Python module ?")

set(X11 OFF CACHE BOOL "GDL: Enable X11 ?") 
set(X11DIR "" CACHE PATH "GDL: Specify X11 directory tree")

# Only GNU Readline since May 2020 (too complex to manage BSD Editline. See #754)
set(READLINE ON CACHE BOOL "GDL: Enable GNU Readline ?")
set(READLINEDIR "" CACHE PATH "GDL: Specify the GNU Readline directory tree")

set(PLPLOTDIR "" CACHE PATH "GDL: Specify the plplot directory tree")

set(GSLDIR "" CACHE PATH "GDL: Specify the GSL directory tree")

set(ZLIBDIR "" CACHE PATH "GDL: Specify the Zlib directory tree")

set(WXWIDGETS ON CACHE BOOL "GDL: Enable WxWidgets ?")
set(WXWIDGETSDIR "" CACHE PATH "GDL: Specify WxWidgets directory tree")

set(UDUNITS2 ON CACHE BOOL "GDL: Enable UDUNITS-2 ?")
set(UDUNITS2DIR "" CACHE PATH "GDL: Specify the UDUNITS-2 directory tree")

set(EIGEN3 ON CACHE BOOL "GDL: Enable Eigen3 ?")
set(EIGEN3DIR "" CACHE PATH "GDL: Specify the Eigen3 directory tree")

set(PNGLIB ON CACHE BOOL "GDL: Enable libpng ?")
set(PNGLIBDIR "" CACHE PATH "GDL: Specify the libpng directory tree")

set(GRIB ON CACHE BOOL "GDL: Enable GRIB ?")
set(GRIBDIR "" CACHE PATH "GDL: Specify the ECMWF ecCodes directory tree")

# set(QHULL OFF CACHE BOOL "GDL: Enable Qhull ?")
# set(QHULLDIR "" CACHE PATH "GDL: Specify the QHULL directory tree")

set(GLPK ON CACHE BOOL "GDL: Enable GLPK (for function SIMPLEX) ?")
set(GLPKDIR "" CACHE PATH "GDL: Specify the GLPK directory tree")

# GraphicsMagick is a good alternative to ImageMagick, if GM OK, we don't look for IM
set(GRAPHICSMAGICK ON CACHE BOOL "GDL: Enable GraphicsMagick ?")
set(GRAPHICSMAGICKDIR "" CACHE PATH "GDL: Specify the GraphicsMagick directory tree")

set(MAGICK ON CACHE BOOL "GDL: Enable ImageMagick ?")
set(MAGICKDIR "" CACHE PATH "GDL: Specify the ImageMagick directory tree")

set(TIFF ON CACHE BOOL "GDL: Enable libtiff ?")
set(TIFFDIR "" CACHE PATH "GDL: Specify the libtiff directory tree")

if(TIFF)
    set(GEOTIFF ON CACHE BOOL "GDL: Enable libgeotiff ?")
    set(GEOTIFFDIR "" CACHE PATH "GDL: Specify the libgeotiff directory tree")
endif(TIFF)

set(NETCDF ON CACHE BOOL "GDL: Enable NetCDF ?")
set(NETCDFDIR "" CACHE PATH "GDL: Specify the netCDF directory tree")

set(HDF ON CACHE BOOL "GDL: Enable HDF ?")
set(HDFDIR "" CACHE PATH "GDL: Specify the HDF directory tree")

set(HDF5 ON CACHE BOOL "GDL: Enable HDF5 ?")
set(HDF5DIR "" CACHE PATH "GDL: Specify the HDF5 directory tree")

set(FFTW ON CACHE BOOL "GDL: Enable FFTW ?")
set(FFTWDIR "" CACHE PATH "GDL: Specify the FFTW directory tree")

set(LIBPROJ ON CACHE BOOL "GDL: Enable PROJ ?")
set(LIBPROJDIR "" CACHE PATH "GDL: Specifiy the PROJ directory tree")

set(MPI OFF CACHE BOOL "GDL: Enable MPI ?")
set(MPIDIR "" CACHE PATH "GDL: Specify the MPI (experimental) directory tree")

set(PYTHON ON CACHE BOOL "GDL: Enable Python ?")
set(PYTHONDIR "" CACHE PATH "GDL: Specify the use Python directory tree")
set(PYTHONVERSION "" CACHE STRING "GDL: Specify the Python version to use")

set(SHAPELIB ON CACHE BOOL "GDL: Enable SHAPELIB (for IDLffShape, MAP_CONTINENTS and all geographic data?)")
set(SHAPELIBDIR "" CACHE PATH "GDL: Specify the SHAPELIB directory tree")

set(EXPAT ON CACHE BOOL "GDL: Enable EXPAT (for IDLffXMLSAX)")
set(EXPATDIR "" CACHE PATH "GDL: Specify the libEXPAT-devel directory tree")

if(NOT WIN32)
  set(NCURSESDIR "" CACHE PATH "GDL: Specify the ncurses (or curses) directory tree")
endif(NOT WIN32)

set(OPENMP ON CACHE BOOL "GDL: Enable OpenMP ?")

# Third party libraries
set(JASPERDIR "" CACHE PATH "GDL: Specify the JasPer directory tree")
set(JPEGDIR "" CACHE PATH "GDL: Specify the JPEG directory tree")
set(SZIPDIR "" CACHE PATH "GDL: Specify the SZip directory tree")

set(GDL_DATA_DIR "/share/gnudatalanguage" CACHE PATH "GDL: data directory relative to CMAKE_INSTALL_PREFIX")

# check for 64-bit OS
if(${CMAKE_SIZEOF_VOID_P} EQUAL 8)
    set(HAVE_64BIT_OS 1)
endif(${CMAKE_SIZEOF_VOID_P} EQUAL 8)

# check for endianness, and set macro in case it is big.
TEST_BIG_ENDIAN(IS_BIGENDIAN)

#### check headers and libraries

# dl
check_library_exists(dl dlopen "" HAVE_DL)
if(HAVE_DL)
    set(LIBRARIES ${LIBRARIES} dl)
endif(HAVE_DL)

# malloc stats
check_function_exists(malloc_zone_statistics HAVE_MALLOC_ZONE_STATISTICS)
check_function_exists(sbrk HAVE_SBRK)
check_function_exists(mallinfo HAVE_MALLINFO)
check_function_exists(mallinfo2 HAVE_MALLINFO2)

# mallocs
check_include_file(malloc.h HAVE_MALLOC_H)
check_include_file(malloc/malloc.h HAVE_MALLOC_MALLOC_H)

# locale
check_include_file(locale.h HAVE_LOCALE_H)

# std includes..
check_include_file(stdint.h HAVE_STDINT_H)
check_include_file(stdlib.h HAVE_STDLIB_H)
check_include_file(string.h HAVE_STRING_H)
check_include_file(strings.h HAVE_STRINGS_H)
check_include_file(sys/stat.h HAVE_SYS_STAT_H)
check_include_file(sys/types.h HAVE_SYS_TYPES_H)
check_include_file(unistd.h HAVE_UNISTD_H)
#check_include_file(ext/stdio_filebuf.h HAVE_EXT_STDIO_FILEBUF_H)
#sometimes it compiles but stdio_filebuf is only in gcc-x-y-z directory tree...
# would be silly not to use this functionality if present, so recheck:
if (HAVE_EXT_STDIO_FILEBUF_H)
else (HAVE_EXT_STDIO_FILEBUF_H)
    check_cxx_source_compiles("
#include <ext/stdio_filebuf.h>
int main(int argc, char **argv) {
    int i=0;
    i+=1;
}" REALLY_HAVE_EXT_STDIO_FILEBUF_H)
endif (HAVE_EXT_STDIO_FILEBUF_H)
if (REALLY_HAVE_EXT_STDIO_FILEBUF_H)
message(STATUS "INFO: will use GNU extensions for STDIO (useful for compressed I/O) since it seems accepted by your c++ compiler.")
set (HAVE_EXT_STDIO_FILEBUF_H 1)
endif (REALLY_HAVE_EXT_STDIO_FILEBUF_H)
# dlfcn.h
check_include_file(dlfcn.h HAVE_DLFCN_H)

# inttypes.h
check_include_file(inttypes.h HAVE_INTTYPES_H)

# nexttoward
check_library_exists(m nexttoward "" HAVE_NEXTTOWARD)

# mpi
check_include_file(mpi.h HAVE_MPI_H)

# SA: whithout it compilation of antlr fails if there's a conflicting 
#     version of antlr in system-wide directories
include_directories(src)

if (NOT WIN32)
    # Ncurses MANDATORY for readline on POSIX
    # -DNCURSESDIR=DIR
    set(CMAKE_PREFIX_PATH ${NCURSESDIR})    
    set(CURSES_NEED_NCURSES TRUE)
    find_package(Curses QUIET COMPONENTS initscr)
    mark_as_advanced(CURSES_CURSES_H_PATH CURSES_FORM_LIBRARY CURSES_HAVE_CURSES_H)
    if(CURSES_FOUND)
        set(HAVE_LIBNCURSES 1)
        set(LIBRARIES ${LIBRARIES} ${CURSES_LIBRARIES})
        include_directories(${CURSES_INCLUDE_DIR})
    else(CURSES_FOUND)
        # search for curses
        set(CURSES_NEED_NCURSES FALSE)
        find_package(Curses COMPONENTS initscr)
        set(HAVE_LIBCURSES ${CURSES_FOUND})
        if(CURSES_FOUND)
            set(LIBRARIES ${LIBRARIES} ${CURSES_LIBRARIES})
            include_directories(${CURSES_INCLUDE_DIR})
        else(CURSES_FOUND)
            message(FATAL_ERROR "(N)Curses was not found.\n"
                "Use -DNCURSESDIR=DIR to specify the curses directory tree.\n"
                "(suitable Debian/Ubuntu package: libncurses-dev)\n")
        endif(CURSES_FOUND)
    endif(CURSES_FOUND)
endif (NOT WIN32)

# -DREADLINE=ON|OFF
# -DREADLINEDIR=DIR
if(READLINE)
  set(CMAKE_PREFIX_PATH ${READLINEDIR})
  find_package(Readline QUIET)
  set(HAVE_LIBREADLINE ${READLINE_FOUND})
  if(READLINE_FOUND)
    if(NOT WIN32)
      # readline needs (n)curses (not on Windows)
      set(CMAKE_REQUIRED_LIBRARIES ${CURSES_LIBRARIES})
    endif(NOT WIN32)
    check_library_exists("${READLINE_LIBRARIES}" rl_get_screen_size "" RL_GET_SCREEN_SIZE)
    if(NOT RL_GET_SCREEN_SIZE)
      message(STATUS "WARNING: Older GNU readline without rl_get_screen_size was found.\n"
    "For resized terminals the size might not be updated correctly.\n"
    "If this is a problem please install a recent version of readline.")
    endif(NOT RL_GET_SCREEN_SIZE)
    set(LIBRARIES ${LIBRARIES} ${READLINE_LIBRARIES})
    include_directories(${READLINE_INCLUDE_DIR})
    set(CMAKE_REQUIRED_LIBRARIES)
  else(READLINE_FOUND)
    message(FATAL_ERROR "GNU readline was not found.\n"
      "Use -DREADLINE=no to explicitely disable it.\n"
      "(suitable Debian/Ubuntu package: libreadline-gplv2-dev or libreadline-dev)\n"
      "(suitable Fedora/CentOS package: readline-devel)")
  endif(READLINE_FOUND)
endif(READLINE)

# zlib MANDATORY
# -DZLIBDIR=DIR
set(CMAKE_PREFIX_PATH ${ZLIBDIR})
find_package(ZLIB QUIET)
set(HAVE_LIBZ ${ZLIB_FOUND})
if(ZLIB_FOUND)
    set(LIBRARIES ${LIBRARIES} ${ZLIB_LIBRARIES})
    include_directories(${ZLIB_INCLUDE_DIR})
else(ZLIB_FOUND)
    message(FATAL_ERROR "ZLib library is required but was not found.\n"
    "Use -DZLIBDIR=DIR to specify the zlib directory tree.\n"
        "(suitable Debian/Ubuntu package: zlib1g-dev)\n"
        "(suitable Fedora/CentOS package: zlib-devel)")
endif(ZLIB_FOUND)

# libpng
# -DPNGLIB=ON|OFF
# -DPNGLIBDIR=DIR
if(PNGLIB)
    set(CMAKE_PREFIX_PATH ${PNGLIBDIR})
    find_package(PNG QUIET)
    set(USE_PNGLIB ${PNG_FOUND})
    if(PNG_FOUND)
        set(LIBRARIES ${LIBRARIES} ${PNG_LIBRARIES})
        set(LINK_DIRECTORIES ${LINK_DIRECTORIES} ${PNG_LIBRARY_DIRS})
        include_directories(${PNG_INCLUDE_DIRS})
    else(PNG_FOUND)
        message(FATAL_ERROR "libpng is required but was not found.\n"
        "Use -DPNGLIBDIR=DIR to specify the libpng directory tree.\n"
        "Use -DPNGLIB=OFF to not use it.\n"
                "(suitable Debian/Ubuntu package: libpng-dev)\n"
                "(suitable Fedora/CentOS package: libpng-devel)")
    endif(PNG_FOUND)
endif(PNGLIB)

# openmp
# -DOPENMP=ON|OFF
if(OPENMP)
  find_package(OpenMP QUIET)
  set(USE_OPENMP ${OPENMP_FOUND})
  if(OPENMP_FOUND)
    if(MSVC)
      set(LIBRARIES ${LIBRARIES} vcomp)
    elseif(WIN32)
      set(LIBRARIES ${LIBRARIES} gomp pthread)
    else()
      set(LIBRARIES ${LIBRARIES} ${OpenMP_CXX_FLAGS})
    endif()
    if(APPLE)
      link_directories(/usr/local/lib)
    endif()
  else(OPENMP_FOUND)
    message(FATAL_ERROR "Your compiler does not support OpenMP or OpenMP was not found"

=== src/CMakeLists.txt ===
set(SOURCES
CFMTLexer.cpp
FMTIn.cpp
FMTLexer.cpp
FMTOut.cpp
FMTParser.cpp
GDLInterpreter.cpp
GDLLexer.cpp
GDLParser.cpp
GDLTreeParser.cpp
datatypes.cpp #long
convol.cpp #long
convol2.cpp #long
smooth.cpp   #long also
basic_op.cpp
basic_op_new.cpp
getas.cpp
basic_op_add.cpp
basic_op_sub.cpp
basic_op_mult.cpp
basic_op_div.cpp
default_io.cpp
ifmt.cpp
ofmt.cpp
datatypes_minmax.cpp
allix.cpp
arrayindex.cpp
assocdata.cpp
basegdl.cpp
basic_fun.cpp
basic_fun_cl.cpp
basic_fun_jmg.cpp
calendar.cpp
color.cpp
convert2.cpp
dcommon.cpp
dcompiler.cpp
dialog.cpp
dinterpreter.cpp
dnode.cpp
dpro.cpp
dstructdesc.cpp
dstructfactory.cxx
dstructgdl.cpp
dvar.cpp
envt.cpp
extrat.cpp
exists_fun.cpp
fftw.cpp
file.cpp
fmtnode.cpp
gdleventhandler.cpp
gdlexception.cpp
gdlgstream.cpp
dSFMT/dSFMT.c
)

if(WIN32)
set(SOURCES
${SOURCES}
otherdevices/gdlwinstream.cpp
gtdhelper.cpp
otherdevices/devicewin.cpp
)
else(WIN32)
set(SOURCES
${SOURCES}
otherdevices/gdlxstream.cpp
)
endif(WIN32)

set(SOURCES
${SOURCES}
gdljournal.cpp
gdlhelp.cpp
gdlpsstream.cpp
gdlsvgstream.cpp
gdlwidget.cpp
gdlwidgeteventhandler.cpp
gdlwxstream.cpp
gdlzstream.cpp
getfmtast.cpp
graphicsdevice.cpp
basic_pro.cpp
basic_pro_jmg.cpp
brent.cpp
grib.cpp
gsl_fun.cpp
gsl_matrix.cpp
gzstream.hpp
hash.cpp
hdf5_fun.cpp
hdf_fun.cpp
hdf_pro.cpp
image.cpp
initct.cpp
initsysvar.cpp
interpolate.cpp
interpol.cpp
io.cpp
lapack.cpp
least_squares.cpp
libinit.cpp
libinit_ac.cpp
libinit_cl.cpp
libinit_gm.cpp
libinit_jmg.cpp
libinit_mes.cpp
libinit_ng.cpp
libinit_jp.cpp
libinit_exists.cpp
linearprogramming.cpp
list.cpp
magick_cl.cpp
math_fun.cpp
math_fun_ac.cpp
math_fun_gm.cpp
math_fun_jmg.cpp
math_fun_ng.cpp
math_utl.cpp
matrix_cholesky.cpp
matrix_invert.cpp
mpi.cpp
ncdf_att_cl.cpp
ncdf_cl.cpp
ncdf_dim_cl.cpp
ncdf_var_cl.cpp
ncdf4_group.cpp
newprognode.cpp
nullgdl.cpp
objects.cpp
overload.cpp
plotting_axis.cpp
plotting_contour.cpp
plotting_convert_coord.cpp
plotting_cursor.cpp
plotting_device.cpp
plotting_erase.cpp
plotting_image.cpp
plotting_misc.cpp
plotting_oplot.cpp
plotting_plot.cpp
plotting_plots.cpp
plotting_polyfill.cpp
plotting_shade_surf.cpp
plotting_surface.cpp
plotting_windows.cpp
plotting_xyouts.cpp
plotting.cpp
print.cpp
print_tree.cpp
prognode.cpp
prognode_lexpr.cpp
prognodeexpr.cpp
projections.cpp
randomgenerators.cpp
read.cpp
saverestore.cpp
semshm.cpp
sigfpehandler.cpp
sorting.cpp
str.cpp
terminfo.cpp
tiff.cxx
triangulation.cpp
typetraits.cpp
where.cpp
widget.cpp
)
if(USE_SHAPELIB)
set(SOURCES
${SOURCES}
Shapefiles.cpp
)
endif(USE_SHAPELIB)
if(USE_EXPAT)
set (SOURCES
${SOURCES}
sax.cpp
)
endif(USE_EXPAT)
if(WIN32)
set(SOURCES
${SOURCES}
gdl.rc
)
endif(WIN32)
if(HAVE_LIBWXWIDGETS AND WIN32)
find_file(WX_RC wx.rc HINTS ${wxWidgets_INCLUDE_DIRS} PATH_SUFFIXES wx/msw)
set(SOURCES
${SOURCES}
${WX_RC}
)
endif(HAVE_LIBWXWIDGETS AND WIN32)

add_subdirectory(antlr)

include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/src/antlr ${CMAKE_BINARY_DIR})
link_directories(${LINK_DIRECTORIES})

if(PYTHON_MODULE) #GDL.so
	add_library(gdl SHARED ${SOURCES})
	SET_TARGET_PROPERTIES(gdl PROPERTIES PREFIX "")
	SET_TARGET_PROPERTIES(gdl PROPERTIES OUTPUT_NAME GDL)
	SET_TARGET_PROPERTIES(gdl PROPERTIES NO_SONAME TRUE)
        SET_TARGET_PROPERTIES(gdl PROPERTIES SUFFIX ".so") # e.g. Mac defaults to .dylib which is not looked for by Python
else(PYTHON_MODULE) #GDL.so
	set(SOURCES ${SOURCES} gdl.cpp)
	add_executable(gdl ${SOURCES})
endif(PYTHON_MODULE)

if(USE_OPENMP)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
endif(USE_OPENMP)

add_dependencies(gdl antlr) # be sure that antlr is built before gdl
target_link_libraries(gdl antlr) # link antlr against gdl
if (MINGW)
target_link_libraries(gdl ws2_32)
endif (MINGW)
target_link_libraries(gdl ${LIBRARIES})
add_definitions(-DHAVE_CONFIG_H)

if(PYTHON_MODULE)
        find_package( PythonInterp ${PYTHONVERSION} REQUIRED )
	execute_process(COMMAND ${PYTHON_EXECUTABLE} -c
		"import site, sys; sys.stdout.write(site.PREFIXES[-1])"
			OUTPUT_VARIABLE PYTHON_PREFIX)
	file( TO_CMAKE_PATH "${PYTHON_PREFIX}" PYTHON_PREFIX)
        execute_process(COMMAND ${PYTHON_EXECUTABLE} -c
		"import site, sys; sys.stdout.write(site.getsitepackages()[-1])"
			OUTPUT_VARIABLE PYTHON_SITE_DIR)
	file( TO_CMAKE_PATH "${PYTHON_SITE_DIR}" PYTHON_SITE_DIR )
	string( REGEX REPLACE "^${PYTHON_PREFIX}/" ""
	       PYTHON_SITE_DIR "${PYTHON_SITE_DIR}")
	install(TARGETS gdl DESTINATION ${PYTHON_SITE_DIR})
else(PYTHON_MODULE)
	install(TARGETS gdl DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
	set_target_properties(gdl PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)
endif(PYTHON_MODULE)

install(DIRECTORY ${CMAKE_SOURCE_DIR}/src/pro/ DESTINATION ${CMAKE_INSTALL_PREFIX}/${GDL_DATA_DIR}/lib
	PATTERN CVS EXCLUDE
	PATTERN checks EXCLUDE
	PATTERN Makefile* EXCLUDE
	PATTERN UrgentNeed.txt EXCLUDE)

install(DIRECTORY ${CMAKE_SOURCE_DIR}/resource DESTINATION ${CMAKE_INSTALL_PREFIX}/${GDL_DATA_DIR}
	PATTERN CVS EXCLUDE
	PATTERN checks EXCLUDE
	PATTERN Makefile* EXCLUDE
	PATTERN UrgentNeed.txt EXCLUDE)

=== testsuite/CMakeLists.txt ===
include(CTest)
set(CTEST_USE_LAUNCHERS 1)

set(BASE_SOURCE ${CMAKE_SOURCE_DIR})
set(BASE_BINARY ${CMAKE_BINARY_DIR})

if (GDLDEV)
  file(GLOB TESTLIST "${BASE_SOURCE}/testsuite/test_*.pro")
else()
  file(READ "${BASE_SOURCE}/testsuite/LIST" TESTLIST)
endif()

add_library(test_ce SHARED EXCLUDE_FROM_ALL libtest_ce.cpp)
add_test(test_build_libtest_ce
  "${CMAKE_COMMAND}"
  --build "${CMAKE_BINARY_DIR}"
  --config "$<CONFIG>"
  --target test_ce
)
file(COPY ${CMAKE_SOURCE_DIR}/testsuite/example.grib DESTINATION ${CMAKE_BINARY_DIR}/testsuite/)

set(GDL_BINARY ${BASE_BINARY}/src/gdl)
set(PATH_SEP ":")
if(WIN32 AND NOT CYGWIN)
  set(GDL_BINARY ${GDL_BINARY}.exe)
  set(PATH_SEP "\\;")
endif()

string(REGEX MATCHALL "test[_a-zA-Z0-9]+\\.pro" TESTS ${TESTLIST})
foreach(TEST ${TESTS})
  string(REGEX REPLACE "\\.pro$" "" TESTNAME ${TEST})
  add_test(NAME ${TEST} COMMAND ${GDL_BINARY} -quiet -e ${TESTNAME})
  if (${TESTNAME} EQUAL "test_call_external")
    set_tests_properties(${TEST} PROPERTIES DEPEND test_build_libtest_ce)
  endif()
endforeach(TEST TESTS)

set_tests_properties(${TESTS} PROPERTIES SKIP_RETURN_CODE 77 TIMEOUT 3600) # autoconf's setting
set_tests_properties(${TESTS} PROPERTIES ENVIRONMENT "LC_COLLATE=C;GDL_PATH=${BASE_SOURCE}/testsuite/${PATH_SEP}${BASE_SOURCE}/src/pro/;GDL_STARTUP=;IDL_STARTUP=")

=== debian/changelog ===
gnudatalanguage (1.0.1-4) unstable; urgency=medium

  [ Bas Couwenberg ]
  * Mark test-gdl autopkgtest as flaky (Closes: #1016425, #1002788)

  [ Ole Streicher ]
  * Increase test_tic_toc tolerance (Closes: #1002584)
  * Switch to wxwidgets3.2 (Closes: #1019782)
  * Remove outdated versionized dependencies
  * Push Standards-Version to 4.6.2. No changes needed.

 -- Ole Streicher <olebole@debian.org>  Tue, 25 Oct 2022 13:23:51 +0200

gnudatalanguage (1.0.1-3) unstable; urgency=medium

  * Lift the usual restrictions on the size of the global offset table
    (Closes: #1001170)

 -- Ole Streicher <olebole@debian.org>  Sat, 11 Dec 2021 13:06:20 +0100

gnudatalanguage (1.0.1-2) unstable; urgency=medium

  * Implement wxApp in Python to fix missing symbol

 -- Ole Streicher <olebole@debian.org>  Fri, 29 Oct 2021 09:21:36 +0200

gnudatalanguage (1.0.1-1) unstable; urgency=medium

  * New upstream version 1.0.1
  * Drop bugfix patch: applied upstream

 -- Ole Streicher <olebole@debian.org>  Thu, 21 Oct 2021 08:41:43 +0200

=== debian/control ===
Source: gnudatalanguage
Maintainer: Debian Astronomy Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Ole Streicher <olebole@debian.org>,
           Axel Beckert <abe@debian.org>,
           Gürkan Myczko <gurkan@phys.ethz.ch>
Section: interpreters
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-python,
               libantlr-dev,
               libeigen3-dev,
               libfftw3-dev,
               libgeotiff-dev,
               libgraphicsmagick++1-dev,
               libeccodes-dev,
               libgsl-dev,
               libhdf4-alt-dev,
               libhdf5-dev,
               libproj-dev,
               libglpk-dev,
               libncurses-dev,
               libnetcdf-dev,
               libplplot-dev,
               libqhull-dev,
               libreadline-dev,
               libtirpc-dev,
               libudunits2-dev,
               libwxgtk3.2-dev,
               plplot-driver-wxwidgets,
               pslib-dev,
               python3-dev,
               python3-numpy,
               xauth,
               xvfb,
               zlib1g-dev
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/debian-astro-team/gnudatalanguage
Vcs-Git: https://salsa.debian.org/debian-astro-team/gnudatalanguage.git
Homepage: https://github.com/gnudatalanguage/gdl
Rules-Requires-Root: no

Package: libgnudatalanguage0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Free IDL compatible incremental compiler shared library
 GNU Data Language (GDL) is a free IDL (Interactive Data Language)
 compatible incremental compiler. It has full syntax compatibility
 with IDL 7.1. IDL is a registered trademark of ITT Visual Information
 Solutions.
 .
 This package contains the shared library which is used by the different
 frontends (gdl binary, Python package).

Package: gnudatalanguage
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: plplot-driver-wxwidgets,
            python3-numpy
Description: Free IDL compatible incremental compiler
 GNU Data Language (GDL) is a free IDL (Interactive Data Language)
 compatible incremental compiler. It has full syntax compatibility
 with IDL 7.1. IDL is a registered trademark of ITT Visual Information
 Solutions. From IDL 8.0, the following language elements are
 supported:
 .
  * FOREACH loop
  * negative array indices
  * garbage collection pointers and objects
  * call methods on an object using "." (e. g. `object.aMemberProcedure,arg1`)
 .
 The file input output system is fully implemented. GUI support (widgets) is
 officially provided, but it's not complete yet.
 .
 This package contains the main commandline and interpreter frontend.

Package: python3-gdl
Architecture: any
Multi-Arch: same
Section: python
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: plplot-driver-wxwidgets
Provides: ${python3:Provides}
Description: Python interface for the GNU Data Language
 GNU Data Language (GDL) is a free IDL (Interactive Data Language)
 compatible incremental compiler. It has full syntax compatibility
 with IDL 7.1. IDL is a registered trademark of ITT Visual Information
 Solutions. From IDL 8.0, the following language elements are
 supported:
 .
  * FOREACH loop
  * negative array indices
  * garbage collection pointers and objects
  * call methods on an object using "." (e. g. `object.aMemberProcedure,arg1`)
 .
 The file input output system is fully implemented. GUI support (widgets) is
 officially provided, but it's not complete yet.
 .
 This package contains the Python library/interface.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

CXXFLAGS += -DBUILD_DATE="\"$(shell LC_ALL=C date -u --date=@"$(SOURCE_DATE_EPOCH)" +'%b %e %Y')\"" -std=gnu++11

# Lift the usual restrictions on the size of the global offset table.
# Taken from the gcc manpage
# earlier taken from https://bugs.debian.org/895214 (less debug info
# to avoid running out of address space)
ifneq (,$(filter $(DEB_HOST_ARCH), mips mipsel))
  export CXXFLAGS += -mxgot
endif

# Workaround for
# https://github.com/gnudatalanguage/gdl/issues/677
LDFLAGS += -Wl,--allow-multiple-definition

%:
	dh $@ -Scmake --with python3

override_dh_auto_configure:
	dh_auto_configure -- \
	  -DDEB_BUILD_MULTIARCH=`dpkg-architecture -qDEB_BUILD_MULTIARCH` \
	  -DHDF5=NO \
	  -DFFTW=YES \
	  -DLIBPROJ4=YES \
	  -DGLPK=YES \
	  -DPYTHON=YES \
	  -DPYTHONVERSION=3 \
	  -DPYTHON_MODULE=YES \
	  -DWXWIDGETS=YES \
	  -DGRIB=YES \
	  -DQHULL=YES \
	  -DUDUNITS=YES \
	  -DPSLIB=YES

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	( cd obj*/testsuite \
	&& $(CXX) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) -o libtest_ce.so ../../testsuite/libtest_ce.cpp -shared -fPIC )
	LD_LIBRARY_PATH="../src" xvfb-run dh_auto_test --no-parallel -Scmake || true
endif


override_dh_compress:
	dh_compress -X.pro

override_dh_auto_install:
	dh_auto_install
	dh_numpy3

## gnudatalanguage 1.0.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,10 @@
 
 cmake_minimum_required(VERSION 3.2 FATAL_ERROR)
 
+if (NOT EXISTS "${CMAKE_SOURCE_DIR}/src/whereami/.git" )
+  message(FATAL_ERROR "The src/whereami git submodule is not initialised.\n Please run `git submodule update --init`")
+endif()
+
 # Set some policies to fix warnings in newer versions of cmake
 # Since VERSION_GREATER_EQUAL is available only since 3.7, we use 
 # VERSION_GREATER combined with VERSION_EQUAL to achieve what we want
@@ -24,12 +28,13 @@
 
 project(GDL)
 set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_C_STANDARD 99)
 
 # advice by Orion, mandatory for FC 28
 set(CMAKE_POSITION_INDEPENDENT_CODE ON)
 
 # X.X.X git becomes release X.X.X+1
-set(VERSION "1.0.1")
+set(VERSION "1.0.3")
 enable_testing()
 
 # cf issue 511, managing MultiArch on Debian ...
@@ -48,7 +53,7 @@
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/CMakeModules)
 #### GDL is an interactive tool. Normally INTERACTIVE_GRAPHICS must be set
-set(INTERACTIVE_GRAPHICS ON CACHE BOOL "GDL: Disable check of existence of a suited graphics driver in plplot.)")
+set(INTERACTIVE_GRAPHICS ON CACHE BOOL "GDL: Disable checking existence of a suited graphics driver in plplot. Only file output may be available, and 3D graphics may NOT work.")
 
 #### Default cached values
 set(GDLDEV OFF CACHE BOOL "GDL: Enable GDL developer mode (includes work-in-progress tests)")
@@ -83,8 +88,8 @@
 set(GRIB ON CACHE BOOL "GDL: Enable GRIB ?")
 set(GRIBDIR "" CACHE PATH "GDL: Specify the ECMWF ecCodes directory tree")
 
-# set(QHULL OFF CACHE BOOL "GDL: Enable Qhull ?")
-# set(QHULLDIR "" CACHE PATH "GDL: Specify the QHULL directory tree")
+set(QHULL ON CACHE BOOL "GDL: Enable Qhull ?")
+set(QHULLDIR "" CACHE PATH "GDL: Specify the QHULL directory tree")
 
 set(GLPK ON CACHE BOOL "GDL: Enable GLPK (for function SIMPLEX) ?")
 set(GLPKDIR "" CACHE PATH "GDL: Specify the GLPK directory tree")
@@ -144,7 +149,14 @@
 set(SZIPDIR "" CACHE PATH "GDL: Specify the SZip directory tree")
 
 set(GDL_DATA_DIR "/share/gnudatalanguage" CACHE PATH "GDL: data directory relative to CMAKE_INSTALL_PREFIX")
-
+set(GDL_LIB_DIR "" CACHE PATH "GDL: library directory relative to CMAKE_INSTALL_PREFIX")
+#define (for plplotdriver/CMakeLists.txt) the GDL_DRV_DIR where the drivers will be installed.
+#if GDL_LIB_DIR is empty, it will be the default (GDL_DATA_DIR/drivers) otherwise it is GDL_LIB_DIR (not GDL_LIB_DIR/drivers)
+if ( GDL_LIB_DIR STREQUAL "" OR NOT GDL_LIB_DIR)
+ set (GDL_DRV_DIR "${CMAKE_INSTALL_PREFIX}/${GDL_DATA_DIR}/drivers") # CACHE PATH "GDL: where the drivers will be installed.")
+else()
+ set (GDL_DRV_DIR "${GDL_LIB_DIR}" ) # CACHE PATH "GDL: where the drivers will be installed.")
+endif()
 # check for 64-bit OS
 if(${CMAKE_SIZEOF_VOID_P} EQUAL 8)
     set(HAVE_64BIT_OS 1)
@@ -214,6 +226,7 @@
 #     version of antlr in system-wide directories
 include_directories(src)
 
+#-------------------------------MANDATORY MODULES-------------------------------------
 if (NOT WIN32)
     # Ncurses MANDATORY for readline on POSIX
     # -DNCURSESDIR=DIR
@@ -284,41 +297,12 @@
         "(suitable Fedora/CentOS package: zlib-devel)")
 endif(ZLIB_FOUND)
 
-# libpng
-# -DPNGLIB=ON|OFF
-# -DPNGLIBDIR=DIR
-if(PNGLIB)
-    set(CMAKE_PREFIX_PATH ${PNGLIBDIR})
-    find_package(PNG QUIET)
-    set(USE_PNGLIB ${PNG_FOUND})
-    if(PNG_FOUND)
-        set(LIBRARIES ${LIBRARIES} ${PNG_LIBRARIES})
-        set(LINK_DIRECTORIES ${LINK_DIRECTORIES} ${PNG_LIBRARY_DIRS})
-        include_directories(${PNG_INCLUDE_DIRS})
-    else(PNG_FOUND)
-        message(FATAL_ERROR "libpng is required but was not found.\n"
-        "Use -DPNGLIBDIR=DIR to specify the libpng directory tree.\n"
-        "Use -DPNGLIB=OFF to not use it.\n"
-                "(suitable Debian/Ubuntu package: libpng-dev)\n"
-                "(suitable Fedora/CentOS package: libpng-devel)")
-    endif(PNG_FOUND)
-endif(PNGLIB)
-
-# openmp
-# -DOPENMP=ON|OFF
-if(OPENMP)
-  find_package(OpenMP QUIET)
-  set(USE_OPENMP ${OPENMP_FOUND})
-  if(OPENMP_FOUND)
-    if(MSVC)
-      set(LIBRARIES ${LIBRARIES} vcomp)
-    elseif(WIN32)
-      set(LIBRARIES ${LIBRARIES} gomp pthread)
-    else()
-      set(LIBRARIES ${LIBRARIES} ${OpenMP_CXX_FLAGS})
-    endif()
-    if(APPLE)
-      link_directories(/usr/local/lib)
-    endif()
-  else(OPENMP_FOUND)
-    message(FATAL_ERROR "Your compiler does not support OpenMP or OpenMP was not found"
+# GSL MANDATORY
+# -DGSLDIR=DIR
+set(CMAKE_PREFIX_PATH ${GSLDIR})
+find_package(GSL QUIET)
+set(HAVE_LIBGSL ${GSL_FOUND})
+set(HAVE_LIBGSLCBLAS ${GSL_FOUND})
+if(GSL_FOUND)
+    set(LIBRARIES ${LIBRARIES} ${GSL_LIBRARIES})
+    include_directories(${GSL_INCLUDE_DIR})

=== debian/changelog ===
gnudatalanguage (1.0.3-1) unstable; urgency=medium

  * New upstream version 1.0.3
  * Rediff patches
  * Install plplot drivers to usr/lib/arch/gnudatalanguage

 -- Ole Streicher <olebole@debian.org>  Thu, 05 Oct 2023 18:50:20 +0200

gnudatalanguage (1.0.2-1) unstable; urgency=medium

  [ Axel Beckert ]
  * Update Gürkan's e-mail address.
  * Remove myself from Uploaders.

  [ Ole Streicher ]
  * New upstream version 1.0.2
  * Rediff patches
  * Push Standards-Version to 4.6.2. No changes
  * Don't use qhull yet

 -- Ole Streicher <olebole@debian.org>  Thu, 19 Jan 2023 16:56:59 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: gnudatalanguage
 Maintainer: Debian Astronomy Team <debian-astro-maintainers@lists.alioth.debian.org>
 Uploaders: Ole Streicher <olebole@debian.org>,
-           Axel Beckert <abe@debian.org>,
-           Gürkan Myczko <gurkan@phys.ethz.ch>
+           Gürkan Myczko <tar@debian.org>
 Section: interpreters
 Priority: optional
 Build-Depends: cmake,
@@ -34,7 +33,7 @@
                xauth,
                xvfb,
                zlib1g-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian-astro-team/gnudatalanguage
 Vcs-Git: https://salsa.debian.org/debian-astro-team/gnudatalanguage.git
 Homepage: https://github.com/gnudatalanguage/gdl

## gnudatalanguage 1.0.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -34,7 +34,7 @@
 set(CMAKE_POSITION_INDEPENDENT_CODE ON)
 
 # X.X.X git becomes release X.X.X+1
-set(VERSION "1.0.3")
+set(VERSION "1.0.4")
 enable_testing()
 
 # cf issue 511, managing MultiArch on Debian ...

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -39,6 +39,7 @@
 dinterpreter.cpp
 dnode.cpp
 dpro.cpp
+dSFMT/dSFMT.c
 dstructdesc.cpp
 dstructfactory.cxx
 dstructgdl.cpp
@@ -49,25 +50,18 @@
 fftw.cpp
 file.cpp
 fmtnode.cpp
+gdlarray.cpp
 gdleventhandler.cpp
 gdlexception.cpp
 gdlgstream.cpp
-dSFMT/dSFMT.c
-)
-
-if(WIN32)
-set(SOURCES
-${SOURCES}
-otherdevices/gdlwinstream.cpp
-gtdhelper.cpp
-otherdevices/devicewin.cpp
-)
-else(WIN32)
-set(SOURCES
-${SOURCES}
-otherdevices/gdlxstream.cpp
-)
-endif(WIN32)
+)
+
+if(NOT WIN32)
+set(SOURCES
+${SOURCES}
+gdlxstream.cpp
+)
+endif(NOT WIN32)
 
 set(SOURCES
 ${SOURCES}
@@ -92,12 +86,14 @@
 hdf5_fun.cpp
 hdf_fun.cpp
 hdf_pro.cpp
+histogram.cpp
 image.cpp
 initct.cpp
 initsysvar.cpp
 interpolate.cpp
 interpol.cpp
 io.cpp
+labelregion.cpp
 lapack.cpp
 least_squares.cpp
 libinit.cpp
@@ -164,6 +160,7 @@
 tiff.cxx
 triangulation.cpp
 typetraits.cpp
+value_locate.cpp
 where.cpp
 widget.cpp
 )
@@ -179,6 +176,12 @@
 sax.cpp
 )
 endif(USE_EXPAT)
+if(HAVE_QHULL)
+set (SOURCES
+${SOURCES}
+qhull.cpp
+)
+endif(HAVE_QHULL)
 if(WIN32)
 set(SOURCES
 ${SOURCES}
@@ -192,10 +195,14 @@
 ${WX_RC}
 )
 endif(HAVE_LIBWXWIDGETS AND WIN32)
+#local plplot drivers
+add_subdirectory(plplotdriver)
+#whereami
+add_library(whereami STATIC ${CMAKE_SOURCE_DIR}/src/whereami/src/whereami.c)
 
 add_subdirectory(antlr)
 
-include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/src/antlr ${CMAKE_BINARY_DIR})
+include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/src/antlr ${CMAKE_SOURCE_DIR}/src/plplotdriver ${CMAKE_SOURCE_DIR}/src/whereami/src ${CMAKE_BINARY_DIR})
 link_directories(${LINK_DIRECTORIES})
 
 if(PYTHON_MODULE) #GDL.so
@@ -213,13 +220,21 @@
 	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
 endif(USE_OPENMP)
 
-add_dependencies(gdl antlr) # be sure that antlr is built before gdl
-target_link_libraries(gdl antlr) # link antlr against gdl
+add_dependencies(gdl antlr whereami) # be sure that antlr is built before gdl
+target_link_libraries(gdl antlr whereami) # link antlr against gdl
 if (MINGW)
 target_link_libraries(gdl ws2_32)
 endif (MINGW)
 target_link_libraries(gdl ${LIBRARIES})
+
 add_definitions(-DHAVE_CONFIG_H)
+
+# Workaround MinGW build problem: force problematic large file to be optimized to prevent string table overflow error
+# see also: https://github.com/assimp/assimp/pull/2418/files
+if ((MINGW) AND (CMAKE_BUILD_TYPE MATCHES Debug))
+	message("-- Applying MinGW basic_op.cpp Debug Workaround")
+	set_source_files_properties(basic_op.cpp PROPERTIES COMPILE_OPTIONS "-Os")
+endif()
 
 if(PYTHON_MODULE)
         find_package( PythonInterp ${PYTHONVERSION} REQUIRED )
@@ -250,3 +265,9 @@
 	PATTERN checks EXCLUDE
 	PATTERN Makefile* EXCLUDE
 	PATTERN UrgentNeed.txt EXCLUDE)
+
+configure_file(
+ 	${CMAKE_SOURCE_DIR}/scripts/quick_start_GDL.sh.in
+	${CMAKE_BINARY_DIR}/quick_start_GDL.sh
+)
+

=== src/plplotdriver/CMakeLists.txt ===
#compile a 'local' version of our patched favorite drivers if we can: enable 3D support and fast plots.
#INSTALL_LOCAL_DRIVERS is set if option INTERACTIVE_GRAPHICS is set and plplot is able to load dynamic drivers.
if(INSTALL_LOCAL_DRIVERS)
  include_directories(${PLPLOT_INCLUDE_DIR}/plplot ${PLPLOT_INCLUDE_DIR} )

  #these drivers are always present
  list(APPEND WHAT "ps" "svg" "mem")
  list(APPEND WHATFILES "mem.driver_info" "svg.driver_info" "ps.driver_info")
  add_library(ps MODULE ps.c)
  target_link_libraries(
      ps
      ${PLPLOT_LIBRARIES}
      )
  add_library(svg MODULE svg.c)
  target_link_libraries(
      svg
      ${PLPLOT_LIBRARIES}
      )
  add_library(mem MODULE mem.c)
  target_link_libraries(
      mem
      ${PLPLOT_LIBRARIES}
      )

  #driver wxwidgets
  if (HAVE_LIBWXWIDGETS) 
    set(LINK_DIRECTORIES ${LINK_DIRECTORIES} ${wxWidgets_LIBRARY_DIRS})
    foreach(WXDEF ${wxWidgets_DEFINITIONS})
        add_definitions(-D${WXDEF})
    endforeach(WXDEF ${wxWidgets_DEFINITIONS})
    include_directories( ${wxWidgets_INCLUDE_DIRS})
    add_library(wxwidgets MODULE deprecated_wxwidgets.cpp deprecated_wxwidgets_app.cpp deprecated_wxwidgets_dc.cpp deprecated_wxwidgets_gc.cpp)
    target_link_libraries(
        wxwidgets
      ${PLPLOT_LIBRARIES}
        ${wxWidgets_LIBRARIES}
     )
     list(APPEND WHAT "wxwidgets")
     list(APPEND WHATFILES  "wxwidgets.driver_info")
   endif(HAVE_LIBWXWIDGETS)

 
  # driver xwin -- check if X11 is present
  find_package(X11 QUIET)
  set(HAVE_X ${X11_FOUND})
  if(X11_FOUND)
    set(LIBRARIES ${LIBRARIES} ${X11_LIBRARIES})
    include_directories(${X11_INCLUDE_DIR})
    add_library(xwin MODULE xwin.c)
    target_link_libraries(
        xwin
      ${PLPLOT_LIBRARIES}
        ${X11_LIBRARIES}
        )
    list (APPEND WHAT "xwin")
    list(APPEND WHATFILES "wxin.driver_info")
 endif(X11_FOUND)



  if(WIN32)
    set(DYNAMIC_SUFFIX ".dll")
  else(WIN32)
    set(DYNAMIC_SUFFIX ".so")
  endif(WIN32)

  foreach(v IN LISTS WHAT)
  set_target_properties(${v} PROPERTIES   PREFIX ""  SUFFIX ${DYNAMIC_SUFFIX} )
  install(TARGETS ${v} DESTINATION ${GDL_DRV_DIR})
  install( FILES ${v}.driver_info DESTINATION ${GDL_DRV_DIR})
  endforeach()

endif(INSTALL_LOCAL_DRIVERS)

=== debian/changelog ===
gnudatalanguage (1.0.4-1build6) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 06:15:38 +0000

gnudatalanguage (1.0.4-1build5) noble; urgency=medium

  * No-change rebuild to build with python3.12 only.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 16 Mar 2024 23:11:24 +0100

gnudatalanguage (1.0.4-1build4) noble; urgency=medium

  * No-change rebuild against libtirpc3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 09:23:55 +0000

gnudatalanguage (1.0.4-1build3) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 06:45:51 +0000

gnudatalanguage (1.0.4-1build2) noble; urgency=medium

  * No-change rebuild with Python 3.12 and eccodes 2.32.2 (2.33, the previous
    rebuild, was removed from noble-proposed)

 -- Andreas Hasenack <andreas@canonical.com>  Fri, 23 Feb 2024 09:15:42 -0300

gnudatalanguage (1.0.4-1build1) noble; urgency=medium

  * No-change rebuild with Python 3.12 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 20 Jan 2024 18:03:09 +0000

gnudatalanguage (1.0.4-1) unstable; urgency=medium

  * New upstream version 1.0.4
  * Rediff patches
  * Drop Increase-test_tic_toc-tolerance.patch: Test logic changed
  * Use external whereami library instead of local copy

 -- Ole Streicher <olebole@debian.org>  Wed, 27 Dec 2023 17:17:52 +0100

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: gnudatalanguage
-Maintainer: Debian Astronomy Team <debian-astro-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Astronomy Team <debian-astro-maintainers@lists.alioth.debian.org>
 Uploaders: Ole Streicher <olebole@debian.org>,
            Gürkan Myczko <tar@debian.org>
 Section: interpreters
@@ -25,6 +26,7 @@
                libreadline-dev,
                libtirpc-dev,
                libudunits2-dev,
+               libwhereami-dev,
                libwxgtk3.2-dev,
                plplot-driver-wxwidgets,
                pslib-dev,

=== debian/rules ===
--- 
+++ 
@@ -33,9 +33,10 @@
 	  -DPYTHON_MODULE=YES \
 	  -DWXWIDGETS=YES \
 	  -DGRIB=YES \
-	  -DQHULL=YES \
+	  -DQHULL=NO \
 	  -DUDUNITS=YES \
-	  -DPSLIB=YES
+	  -DPSLIB=YES \
+	  -DGDL_LIB_DIR=/usr/lib/`dpkg-architecture -qDEB_BUILD_MULTIARCH`/gnudatalanguage
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))

=== debian/tests/control ===
Tests: test-gdl
Depends: gnudatalanguage, xauth, xvfb, plplot-driver-xwin
Restrictions: allow-stderr, flaky

Tests: test-GDL.py
Depends: python3-gdl, python3-pytest, python3-numpy

## gnudatalanguage 1.0.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,6 +13,19 @@
   message(FATAL_ERROR "The src/whereami git submodule is not initialised.\n Please run `git submodule update --init`")
 endif()
 
+# create version string based on git metadata (based on https://github.com/nocnokneo/cmake-git-versioning-example)
+# in case version.hpp does not exist (it is shipped in GDL tarballs but not stored in the repo)
+if (NOT EXISTS "${CMAKE_SOURCE_DIR}/src/version.hpp")
+  find_package(Git REQUIRED)
+  add_custom_target(version
+    ${CMAKE_COMMAND} -D SRC=${CMAKE_SOURCE_DIR}/src/version.hpp.in
+                     -D DST=${CMAKE_BINARY_DIR}/version.hpp
+                     -D GIT_EXECUTABLE=${GIT_EXECUTABLE}
+                     -P ${CMAKE_SOURCE_DIR}/CMakeModules/GenerateVersionHeader.cmake
+    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
+  )
+endif()
+
 # Set some policies to fix warnings in newer versions of cmake
 # Since VERSION_GREATER_EQUAL is available only since 3.7, we use 
 # VERSION_GREATER combined with VERSION_EQUAL to achieve what we want
@@ -33,8 +46,6 @@
 # advice by Orion, mandatory for FC 28
 set(CMAKE_POSITION_INDEPENDENT_CODE ON)
 
-# X.X.X git becomes release X.X.X+1
-set(VERSION "1.0.4")
 enable_testing()
 
 # cf issue 511, managing MultiArch on Debian ...
@@ -54,7 +65,8 @@
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/CMakeModules)
 #### GDL is an interactive tool. Normally INTERACTIVE_GRAPHICS must be set
 set(INTERACTIVE_GRAPHICS ON CACHE BOOL "GDL: Disable checking existence of a suited graphics driver in plplot. Only file output may be available, and 3D graphics may NOT work.")
-
+### compile basic sources monolithically or not, make compilation slow
+set(SPLIT_SOURCES_FILES ON CACHE BOOL "GDL: Force a single compilation for all templates, avoid symbol duplication")
 #### Default cached values
 set(GDLDEV OFF CACHE BOOL "GDL: Enable GDL developer mode (includes work-in-progress tests)")
 
@@ -282,27 +294,3 @@
   endif(READLINE_FOUND)
 endif(READLINE)
 
-# zlib MANDATORY
-# -DZLIBDIR=DIR
-set(CMAKE_PREFIX_PATH ${ZLIBDIR})
-find_package(ZLIB QUIET)
-set(HAVE_LIBZ ${ZLIB_FOUND})
-if(ZLIB_FOUND)
-    set(LIBRARIES ${LIBRARIES} ${ZLIB_LIBRARIES})
-    include_directories(${ZLIB_INCLUDE_DIR})
-else(ZLIB_FOUND)
-    message(FATAL_ERROR "ZLib library is required but was not found.\n"
-    "Use -DZLIBDIR=DIR to specify the zlib directory tree.\n"
-        "(suitable Debian/Ubuntu package: zlib1g-dev)\n"
-        "(suitable Fedora/CentOS package: zlib-devel)")
-endif(ZLIB_FOUND)
-
-# GSL MANDATORY
-# -DGSLDIR=DIR
-set(CMAKE_PREFIX_PATH ${GSLDIR})
-find_package(GSL QUIET)
-set(HAVE_LIBGSL ${GSL_FOUND})
-set(HAVE_LIBGSLCBLAS ${GSL_FOUND})
-if(GSL_FOUND)
-    set(LIBRARIES ${LIBRARIES} ${GSL_LIBRARIES})
-    include_directories(${GSL_INCLUDE_DIR})

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -8,13 +8,15 @@
 GDLLexer.cpp
 GDLParser.cpp
 GDLTreeParser.cpp
-datatypes.cpp #long
-convol.cpp #long
-convol2.cpp #long
-smooth.cpp   #long also
+datatypes.cpp
+)
+ 
+if(NOT ONE_DATAFILE)
+message(STATUS "Using Splitted datatypes.cpp.")
+set(SOURCES
+${SOURCES}
 basic_op.cpp
 basic_op_new.cpp
-getas.cpp
 basic_op_add.cpp
 basic_op_sub.cpp
 basic_op_mult.cpp
@@ -22,6 +24,15 @@
 default_io.cpp
 ifmt.cpp
 ofmt.cpp
+)
+endif(NOT ONE_DATAFILE)
+
+set (SOURCES
+${SOURCES}
+convol.cpp #long
+convol2.cpp #long
+smooth.cpp   #long also
+getas.cpp
 datatypes_minmax.cpp
 allix.cpp
 arrayindex.cpp
@@ -44,6 +55,7 @@
 dstructfactory.cxx
 dstructgdl.cpp
 dvar.cpp
+eigenvalues_solvers.cpp
 envt.cpp
 extrat.cpp
 exists_fun.cpp
@@ -53,6 +65,7 @@
 gdlarray.cpp
 gdleventhandler.cpp
 gdlexception.cpp
+gdlfpexceptions.cpp
 gdlgstream.cpp
 )
 
@@ -60,6 +73,7 @@
 set(SOURCES
 ${SOURCES}
 gdlxstream.cpp
+shm.cpp
 )
 endif(NOT WIN32)
 
@@ -153,8 +167,8 @@
 read.cpp
 saverestore.cpp
 semshm.cpp
-sigfpehandler.cpp
 sorting.cpp
+sparse_matrix.cpp
 str.cpp
 terminfo.cpp
 tiff.cxx
@@ -182,12 +196,14 @@
 qhull.cpp
 )
 endif(HAVE_QHULL)
+
 if(WIN32)
 set(SOURCES
 ${SOURCES}
 gdl.rc
 )
 endif(WIN32)
+
 if(HAVE_LIBWXWIDGETS AND WIN32)
 find_file(WX_RC wx.rc HINTS ${wxWidgets_INCLUDE_DIRS} PATH_SUFFIXES wx/msw)
 set(SOURCES
@@ -195,6 +211,7 @@
 ${WX_RC}
 )
 endif(HAVE_LIBWXWIDGETS AND WIN32)
+
 #local plplot drivers
 add_subdirectory(plplotdriver)
 #whereami
@@ -221,10 +238,13 @@
 endif(USE_OPENMP)
 
 add_dependencies(gdl antlr whereami) # be sure that antlr is built before gdl
-target_link_libraries(gdl antlr whereami) # link antlr against gdl
+target_link_libraries(gdl antlr whereami) # link antlr against gdl. added librt for mmap (unix only, not osx, apparently)
 if (MINGW)
 target_link_libraries(gdl ws2_32)
 endif (MINGW)
+if (NOT APPLE AND NOT OSX AND NOT MINGW)
+target_link_libraries(gdl rt) # link antlr against gdl. added librt for mmap (unix only, not osx, apparently)
+endif (NOT APPLE AND NOT OSX AND NOT MINGW)
 target_link_libraries(gdl ${LIBRARIES})
 
 add_definitions(-DHAVE_CONFIG_H)

=== debian/changelog ===
gnudatalanguage (1.0.6-1) unstable; urgency=medium

  * New upstream version 1.0.6
  * Rediff patches
  * Push Standards-Version to 4.7.0. No changes needed
  * Re-enable HDF5 support
  * Allow some more tests to fail
  * Update d/watch to use github asset as source

 -- Ole Streicher <olebole@debian.org>  Thu, 08 Aug 2024 14:45:03 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: gnudatalanguage
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Astronomy Team <debian-astro-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Astronomy Team <debian-astro-maintainers@lists.alioth.debian.org>
 Uploaders: Ole Streicher <olebole@debian.org>,
            Gürkan Myczko <tar@debian.org>
 Section: interpreters
@@ -8,6 +7,7 @@
 Build-Depends: cmake,
                debhelper-compat (= 13),
                dh-python,
+               hdf5-tools,
                libantlr-dev,
                libeigen3-dev,
                libfftw3-dev,
@@ -35,7 +35,7 @@
                xauth,
                xvfb,
                zlib1g-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/debian-astro-team/gnudatalanguage
 Vcs-Git: https://salsa.debian.org/debian-astro-team/gnudatalanguage.git
 Homepage: https://github.com/gnudatalanguage/gdl

=== debian/tests/control ===
Tests: test-gdl
Depends: gnudatalanguage, xauth, xvfb, plplot-driver-xwin, hdf5-tools
Restrictions: allow-stderr, flaky

Tests: test-GDL.py
Depends: python3-gdl, python3-pytest, python3-numpy

=== debian/watch ===
version=4
opts="searchmode=plain,filenamemangle=s%(?:.*?)?v?@ANY_VERSION@\.tar\.gz%@PACKAGE@-$1.tar.gz%,dversionmangle=s/@DEB_EXT@//,uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\.?\d*)$/$1~$2/,repacksuffix=+dfsg" \
  https://api.github.com/repos/gnudatalanguage/gdl/releases?per_page=100 \
  https://github.com/gnudatalanguage/gdl/releases/download/v\d[\.\d]*/gdl-v@ANY_VERSION@.tar.gz
